<?php
use WHMCS\Database\Capsule;

function xingwaivps_postcurl($urladdress, $fields)
{
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $urladdress);
    curl_setopt($ch, CURLOPT_POST, true);
    //curl_setopt($ch, CURLOPT_HEADER, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($fields));
    $content = curl_exec($ch);
    curl_close($ch);
    return iconv('GB2312', 'UTF-8', $content);
}

function xingwaivps_getcurl($urladdress,$fields){
	$urlfields = "";
	foreach($fields as $k => $v ){
		$urlfields .= $k . "=" . $v . "&";
	}
	$url = rtrim($urladdress.'?'.$urlfields,'&');
    $header = array("HostAPI: whmcs.com", "HostAPIIP: " . $_SERVER["SERVER_ADDR"], "HostAPISITE: " . $_SERVER["HTTP_HOST"]);
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    //curl_setopt($ch, CURLOPT_HEADER, 1);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
    $content = curl_exec($ch);
    curl_close($ch);
    return iconv('GB2312', 'UTF-8', $content);
}

function xingwaivps_MetaData()
{
    return array(
        'DisplayName' => 'XingWaiVps',
        'APIVersion' => '1.1', 
        'RequiresServer' => true
    );
}

function xingwaivps_ConfigOptions()
{
    return array(
        'Vps产品ID' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '1',
        ),
        'Vps机房ID' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '1',
        ),
        'Cpu数量(弹性云必须指定,单位:个)' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '1',
        ),
        '内存大小(弹性云必须指定,单位:MB)' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '0',
        ),
        '硬盘大小(弹性云必须指定,单位:GB)' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '0',
        ),
        '带宽(弹性云必须指定,单位:Mbps)' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '0',
        ),
        'IP数量(弹性云必须指定,单位:个)' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '0',
        ),
        '操作系统ID(弹性云必须指定)' => array(
            'Type' => 'text',
            'Size' => '500',
			'Default' => '0',
        ),
    );
}

function xingwaivps_CreateAccount($params){
	if(substr($params["serverip"], -1) == '/'){
		$params["serverip"] = substr($params["serverip"],0,-1);
	}
	$BuyYear = xingwaivps_buyyearjs($params);
	if(!$BuyYear){
		return '购买年限计算失败';
	}
	if($params['configoption3'] && $params['configoption4'] && $params['configoption5'] && $params['configoption6'] && $params['configoption7'] && $params['configoption8'] && $params['configoption3'] != '0' && $params['configoption4'] != '0' && $params['configoption5'] != '0' && $params['configoption6'] != '0' && $params['configoption7'] != '0' && $params['configoption8'] != '0'){
		$tempcurl = xingwaivps_getcurl($params["serverip"].'/api/cloudapi.asp', array("userid" => $params["serverusername"], "userstr" => md5($params["serverpassword"].'7i24.com'), "year" => $BuyYear, "idc" => $params['configoption2'], "productid" => $params['configoption1'], "action" => 'activate', "CpuValue" => $params['configoption3'], "RamValue" => $params['configoption4'], "VHDValue" => $params['configoption5'], "MbpsValue" => $params['configoption6'], "IPValue" => $params['configoption7'], "OSAllList" => $params['configoption8']));
	}else{
		$tempcurl = xingwaivps_getcurl($params["serverip"].'/api/cloudapi.asp', array("userid" => $params["serverusername"], "userstr" => md5($params["serverpassword"].'7i24.com'), "year" => $BuyYear, "idc" => $params['configoption2'], "productid" => $params['configoption1'], "action" => 'activate'));
	}
	$temp = xingwaivps_contrim($tempcurl);
    if(empty($temp)){
        return '服务器未返回任何有效信息,连接失败....(DebugInfo:'.$tempcurl.')';
    }
    if(@$temp['ret'] != 'ok'){
		if(!$temp['freehosinfo']){
			$errormsg = '未知错误,服务器返回信息:'.$tempcurl;
		}else{
			$errormsg = $temp['freehosinfo'];
		}
        return $errormsg;
    }
    if($temp['vpsname']){
        Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['username' => $temp['vpsname']]);
		Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['domain' => 'vps-'.$temp['vpsname']]);
		if(@$temp['vpspassword']){
		    $PasswdGenresults = localAPI('EncryptPassword',array('password2' => $temp['vpspassword']),Capsule::table('tbladmins')->first()->username);
			if($PasswdGenresults['result'] == 'success'){
				Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['password' => $PasswdGenresults['password']]);
			}
		}
        return 'success';
    }else{
		return '服务器未返回云服务器名称,开通失败';
	}
}

function xingwaivps_Renew($params){
	if(substr($params["serverip"], -1) == '/'){
		$params["serverip"] = substr($params["serverip"],0,-1);
	}
	$BuyYear = xingwaivps_buyyearjs($params);
	if(!$BuyYear){
		return '续费年限计算失败';
	}
    $tempcurl = xingwaivps_getcurl($params["serverip"].'/api/cloudapi.asp', array("userid" => $params["serverusername"], "userstr" => md5($params["serverpassword"].'7i24.com'), "year" => $BuyYear, "vpsname" => $params['username'], "action" => 'renew'));
	$temp = xingwaivps_contrim($tempcurl);
    if(empty($temp)){
        return '服务器未返回任何有效信息,连接失败....(DebugInfo:'.$tempcurl.')';
    }
    if(@$temp['ret'] != 'ok'){
		if(!$temp['freehosinfo']){
			$errormsg = '未知错误,服务器返回信息:'.$tempcurl;
		}else{
			$errormsg = $temp['freehosinfo'];
		}
        return $errormsg;
    }
    //if($temp['vpsname']){
    //    return 'success';
    //}else{
	//	return '服务器未返回云服务器名称,续费失败';
	//}
	return 'success';
}

/**
function xingwaivps_ChangePackage($params){
	if(substr($params["serverip"], -1) == '/'){
		$params["serverip"] = substr($params["serverip"],0,-1);
	}
    $tempcurl = xingwaivps_getcurl($params["serverip"].'/api/cloudapi.asp', array("userid" => $params["serverusername"], "userstr" => md5($params["serverpassword"].'7i24.com'), "productid" => $params['configoption1'], "vpsname" => $params['username'], "action" => 'update'));
	$temp = xingwaivps_contrim($tempcurl);
    if(empty($temp)){
        return '服务器未返回任何有效信息,连接失败....(DebugInfo:'.$tempcurl.')';
    }
    if(@$temp['status'] != 'ok'){
		if(!$temp['freehosinfo']){
			$errormsg = '升级失败,服务器返回信息:'.$tempcurl;
		}else{
			$errormsg = $temp['freehosinfo'];
		}
        return $errormsg;
    }
	Capsule::table('tblhosting')->where('id',$params['serviceid'])->update(['username' => $temp['vpsname']]);
    return 'success';
}
*/

function xingwaivps_ClientArea($params){
	if(substr($params["serverip"], -1) == '/'){
		$params["serverip"] = substr($params["serverip"],0,-1);
	}
	$HashInfo = xingwaivps_gethashinfo($params['serveraccesshash']);
    $temp = xingwaivps_contrim(xingwaivps_getcurl($params["serverip"].'/api/cloudapi.asp', array("userid" => $params["serverusername"], "userstr" => md5($params["serverpassword"].'7i24.com'), "vpsname" => $params['username'], "action" => 'getinfo')));
	if(!$temp){
		return array('tabOverviewReplacementTemplate' => 'templates/error.tpl','templateVariables' => array('ErrorInfo' => '服务器未返回有效信息,请稍后重试'));
	}
    if(!@$temp['vpsname'] || !@$temp['vpspassword'] || !@$temp['cpurl']){
		if(!@$temp['freehosinfo']){
		   $errormsg = '暂无可用控制面板信息,请稍后重试';
		}else{
		   $errormsg = '控制面板信息获取失败,'.$temp['freehosinfo'];
		}
        return array('tabOverviewReplacementTemplate' => 'templates/error.tpl','templateVariables' => array('ErrorInfo' => $errormsg));
    }
	if(@$HashInfo['loginurl']){
		$temp['cpurl'] = $HashInfo['loginurl'];
	}
	if(strpos($temp['cpurl'],'idc-gz') !== false || strpos($temp['cpurl'],'idc-gz') !== false){
		$CpUrl = $temp['cpurl'];
	}else{
		$CpUrl = 'http://'.$temp['cpurl'];
	}
    return array(
        'tabOverviewReplacementTemplate' => 'templates/clientarea.tpl',
        'templateVariables' => array(
            'loginurl' => $CpUrl.'/vpsadm/login.asp',
            'cpurl' => $CpUrl.'/vpsadm/',
            'username'    => $temp['vpsname'],
            'password' => $temp['vpspassword']
        )
    );
}

function xingwaivps_gethashinfo($data){
    preg_match_all( '/<(.*?)>([^<]+)<\/\\1>/i', $data, $matches );
    $result = array();
    foreach($matches[1] as $k => $v){
        $result[$v] = $matches[2][$k];
    }
	return $result;
}

function xingwaivps_buyyearjs($params){
    $billingcycle = $params['model']['attributes']['billingcycle'];
	if(!$billingcycle){
		return false;
	}
	switch ($billingcycle){
	//月付
	case 'Monthly':
	  $hostingcycle = '0.084';
 	  break;
	 //季付
	case 'Quarterly':
	  $hostingcycle = '0.25';
 	  break;
	//半年付
	case 'Semiannually':
	  $hostingcycle = '0.5';
 	  break;
	//年付
	case 'Annually':
	  $hostingcycle = '1';
 	  break;
	//两年付
	case 'Biennially':
	  $hostingcycle = '2';
 	  break;
	//三年付
	case 'Triennially':
	  $hostingcycle = '3';
 	  break;
	default:
	  return false;
	}
    return $hostingcycle;
}

function xingwaivps_contrim($Info){
    $Infoexparr = explode('&',$Info);
    $InfoArray = array();
    foreach($Infoexparr as $Info2array){
    	$Info2exparr = explode('=',$Info2array);
    	if(!$Info2exparr[0]){
    		continue;
    	}
    	if($Info2exparr[1] == null){
    		$Info2exparr[1] = null;
    	}
        $InfoArray[$Info2exparr[0]] = $Info2exparr[1];
    }
	return $InfoArray;
}